========================
Mercenary Sniper HISTORY
========================

-------------------------------
Version:1.05, released:11/04/98
-------------------------------

+ Includes full set of levels (10 at total) and all speeches !
+ Fixed money income (less than in v1.04)
+ Enhanced level design (actually same as in v1.03)
+ Added Miki Nakamura's name to credits
(he has actually drawn only one screen which is used in the game)
+ New opensight lightspot positions adjustment fix


-------------------------------
Version:1.04, released:??/??/98
-------------------------------

** Special DISCCOVER game challenge editition **

<NOTE>
        Only 5 levels and 3 speeches are included in the release.
        In order to get all levels and speeches you have to wait for
        next release... (or get v1.03)

+ Improved sprite blocked check routine (some minor bugs were fixed)
+ Has now a fix for timer reprogramming bug
(hopefully it works now with all systems)
+ Major bug in riflescope buying/selling was fixed -
special thanks to Mika Pulkkinen for informing us about the bug !
+ Enhanced SETUP program
(now there are three new sound options and two new graphics options !)
+ Five new setup options were removed from commandline parameters (clever)
+ Fixed some bugs in SETUP program: now selecting high detail level will
automatically select sprite texturing and when high detail level is selected
sprite texturing is always enabled !
+ SETUP dpmi autoload bug has been fixed now (I had forgotten to stubedit
SETUP.EXE's DPMI path)
+ Fixed a major bug in opensight fullscreen mouse vertical position code
+ Some improvements in configuration file format and supported options
+ Fixed some minor speech bugs
+ New opensights: M16, M60 (= RPK-74 opensight) and MINIGUN (not used yet)
(+ Scenario & Campaign editors are now ready, but I bet I won't be able
to implement support for scenarios & campaigns for game due to lack of
freetime from army...)
+ Fixed money income


-------------------------------
Version:1.03, released:10/01/98
-------------------------------

+ Added impressing fullscreen open sight mode for assault rifles and
machine gun, check it out ! (weapons: M16A1, M16A2, AK47 and RPK74)
-> now there's even more point to buy those sniper rifles... because
open sight mode doesn't support zooming or nightvision like in real
life (except in some cases...) !
-> AGCE medium and high detail rendering modes require even more power
than earlier (Pentium/133MHz+ recommended for those modes !)
-> Blinking in fullscreen was mainly removed via "double buffering"
+ New object: flame
+ New weapon picture: RPK74
+ New intelligent memory allocate routine - continuous freeing at
init time is now totally removed :) -> no memory fragmentation !
+ Fixed bug in 3. enemy fire frame file... kneeing animation was
some how replaced by a machine gunner animation !
+ optimized AGCE normal image scaling routine (open sight fullscreen part)
=> now fullscreen mode sprite drawing is more than 50% faster than earlier !
(quite slow still with my P120+Matrox)
+ Fixed a major mouse X coordinate limit bug...
+ Fixed a position bug in left/right soldier
+ Now CheckHit() supports weapon sight alter x
+ Left edge clippping bug was fixed
+ Updated start screen flame effect (4 bad rows were removed)
-> now it looks a bit better :)
+ Right edge sight move bug was fixed
+ Rifle sight hotspot and relative position bugs were fixed
+ Now real frames per second is told you when exiting to OS (if smooth
refresh is selected from setup)
+ Added helicopter left/right crash frames (not used yet)
+ Fixed flame animation a bit (not used yet)
+ 5 MB of memory is required to run game !
(however Windows 95 allocates 8 MB of memory with my P120+64MB RAM)
+ Level 5 and 10 design bugs were fixed
+ Fixed pixelhit location
+ Fixed a bug in open sight fullscreen mode when merc didn't have a weapon
(weapon was drawn)
+ Speech queue code was totally written... now you won't get bored with
those speeches so easily... (they are repeated less and same speech is
not played simultaneously so many times) :)
+ Zoom level display was removed from fullscreen mode (because you won't
need it anymore)
+ Fixed some possibilities of speech output
+ Optimized masked weapon image draw code (now 100% assembler)
-> now I can achieve with my P120+Matrox even 61 FPS at maximum !
(with old routine I could get only 33 FPS at maximum)
+ Two new game distribution sites: University of Jyv„skyl„ and Viper BBS
Web Server (readme more from www.txt !)
+ Level 6 and 9 briefing texts tell you now before hand that there is
going to be an enemy air assault :)
+ The background of level 10 was replaced by a better one :)
+ Level 10 snow raining was changed to water raining
+ Flame animation width and height were doubled
+ Firing weapon in fullscreen opensight mode will brighten the near area !
-> so you are able to see enemies near sight hotspot when it is dark :)
+ Fixed a bug in circular light spot enabling code, now it works perfectly
+ Added "out of ammunition" speech when you run out of ammunition
+ PSG and Galil Sniper weapons had all same weapon attributes now this
is fixed
+ Fixed again algorithm handling simultaneously speeches
+ Added crash set and fire allocate code (helicopter crash)
+ Now helicopter falls down first and then starts burning and
finally it explodes !
+ Now "out of ammunition" is said when you try to shoot without
bullets :)

NOTE: This version was supposed to be 1.02+ but it was renamed to 1.03
(8 characters wasn't enough for the filename of game archive) 


-------------------------------
Version:1.02, released:04/01/98
-------------------------------

NOTE: This is probably the last release of the game for the present...
because I (the coder) am going to army at January 13th of 1998. And I
will be there for 8-11 months ;) so we hope that you like this release !

+ New miscellaneous item: silencer. Using silencer will reduce damage
caused by a shot... but it will also reduce chance of enemy counter
attack and their alert level increase ! so it is very usable (I think...)
+ Made soundcard deinitialize code more stable... but it still crashes
very often under RAW DOS... ;) (run under Windows DOSBOX to prevent crash)
+ End screen telling you to visit Mercenary Sniper's homepages or at least
to increase the visitor counter...
+ Ability to have three items simultaneously :)
+ Shop (misc. section) was enhanced to support multiple simultaneously
items (naturally)
+ Silencer sound was amplified by 25% (you can hear it now a bit better)
+ Added code to prevent merc having bipod and tripod simultaneously...
+ Replaced pistol sound as button press by a set of nice (?) bonk sounds
+ Now most button presses are followed by this new sound (now you will
hear when you press buttons)
+ 2 new scope types, now less scopes are M16 scopes... :)
+ Bolt-action weapons are loaded faster and they fire faster... so there's
point to buy them...
+ Ability to shoot jeep's driver to death, hit area is not working well yet
(jeep will continue driving left or right, but won't come again)
+ Mission 2 level design was enhanced => prisoners were removed and they
were "replaced" with 4 jeeps :)
+ Added code to prevent enabling AGCE medium/high detail sprite rendering
mode (it won't run well with a 486 processor)
+ Weapon price changes: now all assaultrifles are more expensive and
RPK-74 (machine gun) is also expensive. Barrett M82 is now cheaper and
so is M87 (actually a lot cheaper !).
+ Money income doubled and tripled in some missions :)
+ Fixed (now really) a bug in killed soldier counter code
+ Enhanced -DEBUG parameter action (I think this is only usable for me...)
+ Added soft and loud amplify boost levels (enabled with -SOFT_BOOST and
-LOUD_BOOST commandline parameters read more from readme.txt !)
+ Some modifications to readme.txt
+ READ troubles.txt (especially if you have problems with mouse input !)
+ All helicopter frames are ready (I think) - move left, right, turn
left / right, fire toward ! (maybe some frames are still needed)
+ Improved SETUP.EXE: - now setup uses advanced routines to detect a
SoundBlaster (its baseport, IRQ and with SB16+ even DMA channels).
=> Many people don't have BLASTER environment variable at all. And they
may not know their SB's baseport, IRQ or DMA.
NOTE: These new routines are only used when BLASTER environment variable
is not present (clear it by typing "SET BLASTER=" if it is incorrect and
then run SETUP !).
+ Removed a major bug in dead soldier counting routine (again...) now
it works perfectly (vehicles confused it...) :)
+ Fixed a bug in jeep driver's dying animation... some times wrong animation
frames were shown...
+ Fixed some level design (like level 5.: now it has some jeeps)
+ Now jeep drivers will yell when they are hit :)
+ Fixed a weather density bug now game's weather engine seems to be working
correctly...
+ Now mission 6. has a longer period during "enemy" reborns...
+ Forward coming soldier's in line formation quick level enter bug was
fixed fully :)
+ Fixed some object location bugs in level 5 :)
+ Added small explosion animation
+ Now 4 MB of memory is required (because of new helicopter animation
frames) ;)
+ Compiled with GCC 2.7.2.1 instead of GCC 2.7.2p (Pentium GCC): PGCC is
much slower in compiling than "normal" GCC even with the same optimization
flag (I guess it optimizes more). And for now on it seems that compiling
is more stable (PGCC has crashed tens of times while compiling the game).
+ Pixel hit engine was enhanced even more... now it seems to be working
pretty well...
Optional frequency doubling from 22 KHz to 44 KHz via commandline parameter
-DOUBLE_FREQ (more music/sound quality... at least in theory)
+ More changes to readme.txt (READ IT !)
+ Totally new object distance volume calculate algorithm... now it returns
much better (closer to "real" ones) volume levels...
+ Most of the (transport) helicopter (fly/fire/move) code was added
+ Now autocannon produces small explosions at ground near you when helicopter
fires !
+ Fixed some weapon ammo price bugs
+ Added two pictures of ammunition types to shop (normal and armor piercing)
+ Fixed a bug in mouse event handling code... now hospital heal button
works correctly :)
+ Added ammo base damage display to shop
+ Now weapon vital attributes are shown in shop
(hit accuracy, ammunition type, magsize, recoil, move velocity, reload time
and ROF - rate of fire)
+ 6th mission level design was improved: now there's a transport helicopter !
+ Now enemy base body types have their own hit points
+ Added flame object (animation didn't work well - disabled/removed)
+ Modified 9th mission: now there's a theli (and some objects were removed)
+ Modified some weapon attributes
+ Now you have (only) 5 clips of ammunition at start of your career ;)
+ Fixed a helicopter landing altitude bug
+ Now theli landing/taking off has same sound as flying left or right...
+ New sound: boltaction rifles have their own "clip" reload sound :)
+ Added "hlala" sound to hospital screen after pressing heal button -
experience it !
+ Added ability to buy AP (armor piercing) ammunition from shop :)
+ Adjusted some weapon damages
+ Firing AP ammo will cause 80% of normal damage but will have a 50%
more peneration against vehicles... (especially against helicopter)
+ Added helicopter fireball explosion animation (we hope that you
like it...) 
+ Added explosion sound (not very good quality...)
+ Added helicopter quality texturing (enabled with -HIGH or with
-SHADE_SPRITES commandline parameters)
+ Now all objects benefit from AGCE (Advanced Geometric Correction Engine) !
(even the large ones !) => now -MEDIUM and -HIGH are not recommended unless
you have a Pentium/133MHz+ (or Pentium/166MHz+ for -HIGH) !
+ Unaccuracy event won't happen anymore in pause mode !
+ Now jeeps are also shaded
+ All vehicle frames are now auto quality textured !
+ Now resuming from pause mode will "restore" old mouse coordinates !
+ Now weather raining points won't be moved when in pause mode :)
+ Fixed a stupid bug in AGCE => nearest neighbour routine didn't update
texture u correctly when texture was partially visible


-------------------------------
Version:1.01, released:never :(
-------------------------------

NOTE: This version was never released...

+ Fixed some level design: now harbour doesn't have anymore trees
and desert level (6.) doesn't have anymore heavy snow rain (so it
is more realistic, I think) thanks to my little brother Timo Horppu
of this... :)
+ Now health is displayed as percentages instead of a stupid R(GB)
level
+ Fixed a bug in prisoner's reborn speech (they were assumed to be
enemy soldiers !)
+ Fixed some buggy briefing texts (like 2nd level)
+ Fixed some soldier left/right walking frames
+ Added optional sprite shading (-SHADE_SPRITES commandline parameter)
+ Now health is also displayed as percentages in hospital !
+ Prisoner last animation frames were fixed (in left and right walking)
+ Most of the briefing texts were enhanced (now there's some text
of prisoners, etc)
+ CheckBlocked() routine was improved => now left/right walking object
can have "easier" access to start walking toward (this is really needed !)
+ Improved enemy AI => now when enemy soldier is shot to death a counter
attack "signal" can be sent to all left / right walking soldiers ! (and
after that they start walking toward and start seeking you !)
+ Fixed some hospital bugs (pressing heal button is still "hard" ...)
+ Fixed soldier left and right walk frames
+ Now texture u and v coordinates are 256 times more accurate (in 1/65536
units) hopefully this will improve a bit scaled sprite quality :)
+ Added soundcard irq's IRET wrapper freeing code this reduces crashes
in DOS (after exiting to DOS from game)... but doesn't eliminate them
totally ;)
+ Limited Hall Of Fame name length to 14 characters from old 16 chars
+ Now AK47 uses 7.62mm ammo instead of 5.45mm (AK74 uses 5.45mm ammo and
it is not in the game !) sorry about that... ;)
+ Fixed a bug in kills needed in a mission (if there were machine gunner(s)
or (anti)-sniper(s) level was assumed to be clear even if there left some
enemies...)
+ Added UAZ jeep left/right moving frames (coming soon driver dying
frames) => and level(s) using these new two objects :) we will need
a level with a road (asphalt or sand). => not used yet !
+ Modified readme.txt a bit => I recommend reading readme.txt in order
to get more details of the game and stuff like that !
+ Added transport helicopter left/right flying frames (coming
crashing animation) => not used yet !
+ Splitted some sourcefiles into smaller parts... this was required
because DJGPP 2.7.2p went to infinite compiling loop and didn't return
from it... main.cpp was over 100 kilobytes now it is only 80 kilobytes
and seems to work well :)
+ Got some new graphics (special thanks to Tuomas Aikioniemi): new
shop screen, pictures of weapons / ammunition, more helicopter frames,
etc... :)
+ Briefing text bg will is now transparent - reading of the text is
easier than earlier !
+ Soldiers have now a 7 "base" size types: width and height may
differ +- 10%
+ Some of soldier left/right movement frames were fixed
+ Fixed many transparency bugs in some animation frames !
+ Briefing screen darkness bug was fixed (when loading a saved game) this
was really needed ! :)
+ Stupid module player didn't restore original XM file bpm and speed when
restarting module (hopefully you didn't notice this in shop...)
+ Added six "real" weapon pictures to shopping screen (weapon section)
special thanks goes also to Tuomas from this... - hopefully he will get
drawn all 13 (7 more) pictures in near future done !
+ Now riflescope "aiming spot" is not drawn at all if you don't have
a weapon (very clever...) :)
+ Improved pixel hit engine: ground pixel hits have now a bigger flying
radius and other have less flying radius...
+ 262144 entries RGB LUT transparency bugs were fixed... (prisoners
boots were "suffering" from hits... etc)
+ RPK-74 now uses 5.45mm ammo instead of 7.62mm
+ Added pause key - 'P'
+ Added render mode toggle key - 'G'
(Sprite quality texturing must be enabled in order to get everything
out of Bilinear Interpolation render mode... read more from readme.txt !)
+ Prisoner frames were enhanced by 100%... now they look better and have
less animation "bugs"...
+ Now riflescope zooming routine also uses 256 times more accurate texture
u and v coordinates (in 1/65536 units)
+ A section of commandline parameters was added to readme.txt (read it !)
+ added "Mission failed" speech (after you shoot a prisoner)
+ Fixed some weird frequency bugs (after adding this mission failed
speech HOF bg module frequencies were too low...) now it works correctly :)
+ 6 new blocks (3 summer trees and 3 winter trees) thanks to Tuomas again :)
+ Improved level design in missions 3 and 4 (and in some other also...)
+ Missing riflescope index bug was fixed
+ Fixed a bug in unaccuracy event code... (M82 rifle could go down
continuously...)
+ New dying soldier will fly in air when he is shot to death (so dying
is now more realistic)... coming soon damage affect to range soldier
is flown !
+ Advanced Geometric Correction Engine (AGCE) - cool name, eh?
+ Now lowercase commandline parameters are also accepted :)
(+ Improved a bit Mercenary Sniper's homepages: - screenshots were
modified, dark pictures' brightness and contrast were added by 10%)


-------------------------------
Version:1.00, released:20/12/97
-------------------------------

+ Added support for weapon specified scope zooming level and step
+ Scope zooming bug was fixed now you can't make zoom level less
than 100% (this may have caused some crashes in earlier versions !)
- Noticed that: scope spot flickers too much if you use fast screen
refresh method and unaccuracy events occur too many times =>
setup program was fixed a bit... now it selects automatically smooth
screen refresh method which eliminates these "bugs" partially...
+ Fixed some weapons fire rates (m16a1, m16a2 and ak47)
+ Setup program enhanced even more now 512 byte DMA buffersize is selected
by default (256 bytes was too less at least with my system under Win95...)
=> now sound quality should be better by default :)
+ Prober weapon zooming levels added (maximum zoom and zoom step were
set, currently all weapons have minimum zoom level of 100% ...)
+ Added pixel hit engine (soldiers, trees, stones, ground !)
+ Improved level design (almost all levels are now enhanced a bit !)
+ Artificial Intelligence was enhanced, enemy soldiers are a bit
smarter than earlier. (added enemy alert level which may increase
when enemy soldier dies or you just shot ground or something...)
+ Fixed a stupid hospital recost bug :)
+ Now toward walking is more common than earlier !
+ Added two stationary object types (level 2 & 3 !)
+ Super fast close animation speed bug was fixed :)
+ Both major and minor level design changes
+ Removed almost 5 serious memory write bugs !
+ Added a new unit: sniper ! (they have a better shooting accuracy
than machine gunners but they cause less damage...)
+ Added support for left or right channel Dolby Surround !
(-DOLBY_LSURROUND AND -DOLBY_RSURROUND cmdline parameters)
NOTE:
You won't gain much of this because musics are not designed to take
full advantage of this... the only advantage is that if you have a
soundcard which supports enhanced "3D" stereo mode then this will
make effects sound better :)
PS. If you have a SB16 or AWE then you should have a CT3DSE.EXE. Before
enabling left or right channel surround you'd better run CT3DSE with
parameter "ON" to enable enhanced stereo effects !)
+ Fixed a reversed mouse movement pixel hit bug ;)
+ Enhanced level design even more :)
+ Added an ability to buy/sell scopes and miscellaneous items
+ Full usage of scopes/misc. items
+ Added weather "report" to briefing text (it may not be right
always...)
+ Fixed a bug in sniper killing (it was almost impossible) but it
is still hard... HINT: don't shoot one position of the sniper shoot
the sniper all over the body...
+ Debugged levels
+ Added some vital parts to readme.txt => now the game is not as
plotless as the v0.97 was... (though quite plotless still...)

added at 21/12/97 (didn't want to change the version number...)
+ Fixed some dying transparency bugs (at least 2 frames were fixed)
+ Fixed a stupid font coloring bug in nightvision / thermal sight mode !
+ Added a prisoner object (currently just walking left or right) and no
killing animations yet (do not shoot these or your mission will fail !)
+ Fixed some prisoner animation bugs
(missing/transparent headpixel rows, etc)
+ Enemy soldiers can now "dive" to ground and shoot from there if they
are being hit (not very smart but better than nothing...)
+ Some levels were modified to have prisoners :)


-------------------------------
Version:0.99, released never :(
-------------------------------

+ Fixed a bug in load saved career option (when save file didn't exist
game assumed that everything went ok...)
+ Weapon damage differs from earlier versions (damage caused by a shot
is affected by ammo type)
+ New scope
+ Fixed a bug when buying a new weapon from shop => now mouse velocity
is set only at start of a new level :)
+ Fixed a bug which caused game not to load a saved game correctly :)
+ Briefing screen text bug was fixed => now text should be correct :)
+ Many level design bugs were fixed (now it is possible to play through
all the 10 levels !)
+ Fixed a stupid autosave bug :)
+ Hospital was added (now you have an ability to be healed if you have
enough money...)

**NOTE (ONLY IF YOU HAVE SELECTED A SOUNDCARD FROM SETUP !)**
I noticed that game seems to be very unstable under raw DOS mode =>
please run game under Windows 95 to minimize possible damages caused
to your system (enable protect memory option in order to ensure that
no damage is caused !)


-------------------------------
Version:0.98, released:05/12/97
-------------------------------

+ "Info" after start a new career option:
        - Ask mercenary name
        - Show weapon info
        - Show mercenary info (experience, rank, etc !)
+ CWSDPMI r3 was replaced with r4 :)
+ Some major initialization (during the data load) bugs were fixed !
+ Support for command line parameters added:
  => Check out "/?" or "-?" for more about these parameters)
+ Weapon & ammo datas (not fully implemented yet)
(13 different weapons, 4 main ammo types, 1 special ammo type)
+ Support for following weapon attributes:
        - base hit accuracy
        - movement velocity
        - recoil
        - ammo in magazine
        - scope type
        - reload time
        - fire rate
=> now shooting is more realistic because there's base hit accuracy
attribute and it is used !
+ Zooming routine was rewritten (inner loop is now assembler)
=> routine is 2-4x faster than the old one !
+ Infrared sight mode was changed to nightvision mode (cooler)
+ Added support for 6 different scopes ! (3 new ones)
+ Added game debug mode (-DEBUG commandline parameter)
=> Only for game developers ! - no much use for other people... ;)
+ Clip and ammo count display => will help you to remember how much
or less ammo you still have left !)
+ Shopping screen (weapon & ammo section is almost ready, only
buy/sell buttons are missing, scopes & misc coming soon !)
+ All attributes for 13 different weapons were verified :)
+ Enabled key 's' - toggle sight mode (normal/night vision)
+ very bad object blocked bug was fixed ! (or actually improved a lot !)
+ Fixed a major mouse sensitivity setting bug - Microsoft Mouse Driver
"API" was used => now Mousev1.0 API is used (more compatible !) and
horizontal sensitivity is set also !
+ Removed mouse sensitivity settings from setup (they are no more used !)
+ Added object toward side walk code (hopefully it works...)
+ Original mouse velocity is now restored :)
+ Continuous speeches & sounds... now this new algorithm works !
+ Dummy first sight toggle was fixed
+ Stupid sight mode update bug was fixed (when starting a new level with
a different sight mode than normal sight, now sight mode is (re)set to normal
before starting a level...)
+ Bug in memory reallocate was fixed => no more memory fragmenting !
+ Level 4 (and some other levels too !) machine gunner(s) bug was/were fixed
(Thanks to Tuomas Huttunen) NOTE: this bug fix is not tested well yet...
so give me more feedback it this doesn't work yet ;)
=> if this still happens then please send me the save file
(.\savegame\msniper.sav) before the "buggy level" and then
I am able to fix it...
+ Added load/save game option (currently only for a one game...)
+ Improved some game event structures
+ Money gaining from missions (constant amount currently...)
+ Changing sightmode "cleared" blood level to zero now blood level is
saved :)
+ Some shopping bugs were fixed hopefully it works now :)
+ List of 'Official' Mercenary Sniper download sites (MBNET, SOLUTIONS, JYU)
was added to the game package :)
+ Added a cool music to shopping screen ("Take No Prisoners" by Timo Horppu)
+ Added 4 cool weapon sounds (AK47, RPK74, silenced MK2 and biggun(s) !)


-------------------------------
Version:0.97, released:16/11/97
-------------------------------

+ Better zooming routine (now background is also zoomed !) and this
code is 2-4 times faster than the old one ! but only problem is that
the rifle aim started to flicker and zooming routine has a small bug ;)
+ A new perspective engine should be more realistic, I think... ;)
+ Improved object handling engine a bit (now different object types are
easier to be implemented)
+ Game's name changed from "Sniper" to "Mercenary Sniper" !
+ Improved vehicle event code (though vehicles are not supported yet)
+ Added a new tree type (actually 3 different objects !)
+ Totally enhanced start screen (with cool bg flame animation) :)
+ Start menu "options" were renamed (but load career is not supported yet)
+ Fixed a stupid zero Z-level bug (some levels were infinite...) :)
+ Briefing screen crashes are now away... (hopefully)


-------------------------------
Version:0.96, released:??/11/97
-------------------------------

+ Smooth screen update is now faster than earlier :)
+ Start & end ANSI screens were (partially/fully) be removed
(I guess this is enough tested...)
+ Noticed that SoundBlaster interrupt handler installing &
restoring works perfectly in other program... it seems that
something other generates those nasty RMCB errors especially
when EMM386 has been loaded ;)
+ Improved a bit game's event handler (now timing is correct
on all levels...)
+ Changed start screen (removed duplicated credits and stupid
side bars...)
+ Added a new bg module by Adex :)
+ Removed initialization text grab as much as possible !
+ Added code to handle vehicle game events :)
+ Levels were enhanced (but not ready yet !) :)
+ Blocked direction check routine was improved because objects
could walk through vehicles !
+ Enemy fire is more accurate than ever ;)
+ Machine gunner has now a better gun flame animation :)
+ Some animation speeds were altered/fixed :)


-------------------------------
Version:0.95, released never ;)
-------------------------------

+ Side walking soldiers won't walk over machine gunners !
+ Totally new bolt action rifle sight
+ Fixed a bug in BA rifle aim center position !
+ Machine gunner really hurts you !
+ Version number was updated from 0.93 to 0.95 (0.94 never existed in public)
+ Added Dj Basher + Adex's name to credit/main screens :)
+ Normal mouse cursor was removed from start screen (finally)
+ Now game is a easier :)
+ Mouse button press is accepted as key press in start screens !
+ Fixed a bug in mouse button pressing accepting code :)
+ 10 real levels (constant stationary object base positions !)
+ Got ready a beta version of Sniper Mission Editor :)
+ Fixed a major bug which caused system to crash totally (at least
with soundcard) when displaying error message in text mode :)
+ After adding all stuff I noticed that the game crashes randomly !
(even under DOS !) bad memory read/write offset(s), debugging ;) this
seems to happen only with reverse mouse movement... it shouldn't but
it happens :(
+ Detected that this program won't free/restore all necessary PIC
values or IRQs before exiting to DOS... because running some programs
after this game may hang your system (if you are under Windows 95
then DOS-BOX is closed automatically by Windows because of violation
error or something !) this should be removed but I have no idea what
causes this... :(
+ Removed LZO (1X-999) library and ETM (Extreme Tracker) module loader
because they are not used anymore by this game ;) => sniper.exe size
reduced a few thousands of bytes :)
+ Remembered that software XM playback routine is buggy it doesn't
support looping, envelopes nor multisample instruments, this is the
reason why you can hear some clicks in new intro music :(
+ Sample playback routine should be now a bit more stable than ever :)
+ machine gunners won't start firing before you are really in the game !
+ Real briefing screen (= mission text) before starting level !
+ Prototype of a moving vehicle was added ! (though not used yet...)
+ Detected a crash bug when using EMS (or Windows DOS-BOX) after freeing
soundcard stuff => this will crash your system (in DOS mode) and produce
a GPF in Real Mode Call Back (RMCB)... this is currently being traced... ;)
+ Fixed a bug which caused soldier health to be "virtually" 0% at the start
of a level !
+ Coded a Sniper Mission (File) Editor (though not available in public),
this version of the game takes advantages of the SMF level format, though
it is not final yet...
+ Fixed a bug in fisheye perspective scale and location calculate code ;)
(now objects with different heights have correct z positions !)
+ Fixed a darkness bug in briefing screen :)
+ Speech and sample files were all put in a one (big) sound bank file
(I hope you will appreciate this...)
+ Added new SoundBlaster IRQ PIC and handler & DMA transfer stop code,
now exiting to DOS is more safe than ever... but GPF is still generated
randomly :(


-------------------------------
Version:0.94, released never ;)
-------------------------------

+ Now trees are drawn in real size (you will notice this...) !
+ Enemies won't walk through trees and rocks anymore !
+ Side walking enemies can now change their moving direction to towards
if possible...
+ Fixed a bug in sprite animation engine... now action can be changed without
buggy "middle" frame... !
+ left/right movement will be changed to toward movement when possible...
(this is not yet as perfect as possible but still...)
+ Soldier left/right movement is now a lot better (thanks to Tuomas !)
+ You can zoom closer/away from a or z (100%+>800%) : *WARNING* be aware of
the fact that zooming may eat a lot more CPU cycles than normally !
+ Now you should not be anymore able to shoot soldiers behind trees and
rocks !
- Noticed that GPF errors may still occur while exiting to OS :(
+ Added draw code for "very+old" bold action rifle scope and for IR
(Infra Red) M16 rifle scope (!)
+ Added support for level darkness (IR !)
+ Improved a bit soldiers' reborn group forming code :)
+ Dj Basher's (Adex's) new background music module
+ ska's intro music (replaces old intro music by K”pi) because this is
a better one...
+ (More) continuous speeches & sounds... hopefully they will now work
well on all systems... (a major bug in XM module loader)  :)
+ machine gunner + cool mgun sound :)
+ Laying soldiers can now die in two different ways (shot at abdomem
or head but the animations are random so far...)


-------------------------------
Version:0.93, released 22/08/97
-------------------------------

+ Added briefing screen (the big boss before going level !)
+ Bug in aiming with reversey mouse pointer movement fixed !
+ This is not anymore a test release of the game ! so many
beta testers have verified that this game is working pretty
well on various systems :)
+ Now graphics files for boat & prisoners are included !
(they are used after I got missions & briefings done)
+ Speed up some graphics routines (not much effect to overall performance)
+ Windows' DOSBOX detect (warning about performance / smoothness losses !)
+ Major bug in mixing engine fixed... now mono data is played correctly
with 8/16+bit mono mixing modes ;)
+ For now on you will need at least a 486 processor to play the game ;)
+ Fixed some minor bugs in font drawing routines
+ Fixed some bugs in compressed data file decoder :)
+ Added a Windows icon :)


----------------------------------------------
Version:0.92 (TEST RELEASE), released 12/08/97
----------------------------------------------

+ Some minor changes in code ;)
+ Start screen picture & menu !
+ You are no longer told not to distribute this game :)
+ Now exiting to Operating System from game shouldn't crash
most system any more (updated iret wrapper free code & font
free code & SB driver free code)
+ Chance of "radio" speech is now much less than in earlier
versions (you won't get bored with the speeches at least so
easy as earlier)


----------------------------------------------
Version:0.91 (TEST RELEASE), released 01/08/97
----------------------------------------------

+ 8 speeches (mixed at 8+BIT 11 KHz MONO)
+ 3 additional speech files
+ Fixed some volume distance bugs
+ 3 new background graphics !
+ New cool Sniperrock music by Monz !
+ Improvemed general module playing engine
(now it supports wider range of XM/ETM effects, etc)
+ Game won't anymore crash if select no soundcard after
  start intro screen (this was a stupid bug hopefully you
  didn't suffer from it...)
+ Now Sniper homepage address is displayed when exiting
  from game (check it out !)
+ Fixed a VERY MAJOR BUG which caused MOUSE IRQ not TO BE
GENERATED ! (Maybe SB code modifies PIC1 & PIC2? and I guess
it does something what it shouldn't...) This was very weird
bug because this didn't exist in Windows ! This is actually
not fixed yet... because I didn't found the part of code which
causes this... I just moved to mouse init code to before my
IRQ PIC1 modify code now everything works just fine :)
+ 2 new background graphics (now total of 10 !)


----------------------------------------------
Version:0.90 (TEST RELEASE), released 09/07/97
----------------------------------------------

+ This file was included, I started to keep track of game's history :)
+ 3 background musics (though only one is really usable during the game)
+ 3 more dying yells and 1 more suffering yell
+ Now laying dying soldiers are really dying in ground =)
+ Changed mixing rate to 22050 Hz
(better quality with music samples like hihats, etc)
+ Shaded soldiers' uniforms !
+ Added 2 new rank levels to hall of fame (syndicate & terminator !)
+ Gaining new rank is now easier than never before
(just shoot enough enemies to gain better rank)
+ Enhanced some dying yells (hopefully you will hear which ones)

